// GetHostDlg.cpp : t@C
//

#include "stdafx.h"
#include "WinWol.h"
#include "GetHostDlg.h"
#include "afxdialogex.h"
#include "GlobalFunc.h"


// CGetHostDlg _CAO

IMPLEMENT_DYNAMIC(CGetHostDlg, CDialog)

CGetHostDlg::CGetHostDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGetHostDlg::IDD, pParent)
	, m_EdtHostName(_T(""))
{
	m_IpAddr = _T("");
	m_Type = 0;
}

CGetHostDlg::~CGetHostDlg()
{
}

void	CGetHostDlg::UpdateHostName(void)
{
	UpdateData(TRUE);

	DWORD	dwAddr;

	if (m_CtlIpAddr.GetAddress(dwAddr) == 4) {
		char buf[64];

		DwToStrIpAddr(dwAddr, buf, sizeof(buf));

		m_IpAddr = buf;

		if (!GetHostNameFromIpAddr(m_IpAddr, buf, sizeof(buf)) || !buf[0]) {
			CString	str;
			str.LoadString(IDS_STRING_HOST_NAME_NOT_FOUND);
			MessageBox(str);
			return;
		}
		m_EdtHostName = buf;
	}
}

void CGetHostDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_IPADDRESS_IPADDR, m_CtlIpAddr);
	DDX_Text(pDX, IDC_EDIT_HOST_NAME, m_EdtHostName);
}


BEGIN_MESSAGE_MAP(CGetHostDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_SRCH_HOST, &CGetHostDlg::OnBnClickedButtonSrchHost)
END_MESSAGE_MAP()


// CGetHostDlg bZ[W nh[

BOOL CGetHostDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ɏǉĂ
	if (!m_IpAddr.IsEmpty()) {
		m_CtlIpAddr.SetAddress(StrToDwIpAddr((LPCTSTR)m_IpAddr));
	}	
	UpdateData(FALSE);

	CWnd	*pWnd = GetDlgItem(IDOK);
	if (pWnd) {
		if (m_Type) {
			pWnd->ShowWindow(SW_SHOW);
		} else {
			pWnd->ShowWindow(SW_HIDE);
			pWnd = GetDlgItem(IDCANCEL);
			if (pWnd) {
				CString	str;
				str.LoadString(IDS_STRING_CLOSE);
				pWnd->SetWindowText(str);
			}
		}
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

void CGetHostDlg::OnOK()
{
	// TODO: ɓȃR[hǉ邩A͊{NXĂяoĂB
	UpdateHostName();

	CDialog::OnOK();
}

void CGetHostDlg::OnBnClickedButtonSrchHost()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	UpdateHostName();

	UpdateData(FALSE);
}

